// ChildView.cpp : implementation of the CChildView class
//

#include "stdafx.h"
#include "MFCWndTestAX.h"
#include "ChildView.h"

#include <AFXPRIV.H> //USES_CONVERSION, A2W, W2A

#include "..\helpers.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CChildView

CChildView::CChildView()
{
	//m_iGrid=-1;
}

CChildView::~CChildView()
{
	//MDZSimpleGrid::DestroyGrid(m_iGrid);
}


BEGIN_MESSAGE_MAP(CChildView,CWnd )
	//{{AFX_MSG_MAP(CChildView)
	ON_COMMAND(ID_VIEW_COLORS, OnViewColors)
	ON_WM_CREATE()
	ON_WM_SIZE()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CChildView message handlers

BOOL CChildView::PreCreateWindow(CREATESTRUCT& cs) 
{
	if (!CWnd::PreCreateWindow(cs))
		return FALSE;

	cs.dwExStyle |= WS_EX_CLIENTEDGE;
	cs.style &= ~WS_BORDER;
	cs.style |=WS_CLIPCHILDREN;
	cs.lpszClass = AfxRegisterWndClass(CS_HREDRAW|CS_VREDRAW|CS_DBLCLKS, 
		::LoadCursor(NULL, IDC_ARROW), HBRUSH(COLOR_WINDOW+1), NULL);

	return TRUE;
}

int CChildView::OnCreate(LPCREATESTRUCT pstCreate)
{
	CRect rctClient;
	GetClientRect(rctClient);

	if(!m_wndGrid.Create(NULL,WS_VISIBLE | WS_CHILD | WS_BORDER,rctClient,this,10))
	{
		MessageBox("Cannot create grid control");
		return TRUE;
	}

	USES_CONVERSION;
	try
	{
		HRESULT hRes;
		if(FAILED(hRes=m_wndGrid.GetControlUnknown()->QueryInterface(IID_IMDZSimpleGrid,(void**)&m_piGrid)))
			throw hRes;

		if(FAILED(hRes=m_piGrid->AddColumn(A2W("Id"),-1))) //v-table usage
			throw hRes;
		
		m_wndGrid.AddColumn("Name",-1); //dispinterface usage

		if(FAILED(hRes=m_piGrid->AddColumn(A2W("Birthday"),-1)))
			throw hRes;
		if(FAILED(hRes=m_piGrid->AddColumn(A2W("Address"),-1)))
			throw hRes;
		if(FAILED(hRes=m_piGrid->AddColumn(A2W("Salary"),-1)))
			throw hRes;

		srand(time(NULL));
		char pcBuff[20];
		for(int i=0;i<100;i++)
		{
			if(FAILED(hRes=m_piGrid->AddStringData(A2W("Id"),
													A2W(itoa(i+1,pcBuff,10)))))
				throw hRes;
			if(FAILED(hRes=m_piGrid->AddStringData(A2W("Name"),
													A2W(GenerateName(i).c_str()))))
				throw hRes;
			if(FAILED(hRes=m_piGrid->AddStringData(A2W("Birthday"),
													A2W(GenerateDate().c_str()))))
				throw hRes;
			if(FAILED(hRes=m_piGrid->AddStringData(A2W("Address"),
													A2W(GenerateAddress().c_str()))))
				throw hRes;
			if(FAILED(hRes=m_piGrid->AddStringData(A2W("Salary"),
													A2W(GenerateSalary().c_str()))))
				throw hRes;
		}
		if(FAILED(hRes=m_piGrid->RecalculateLayout()))
			throw hRes;
	}
	catch(HRESULT hErrorRes)
	{
		MessageBox(GetErrorMessage(hErrorRes).c_str());
	}
	m_piGrid->Release();
	return 0;
}

void CChildView::OnViewColors() 
{
	m_wndGrid.ChangeColors();
}

void CChildView::OnSize(UINT, int cx, int cy)
{
	if(!m_wndGrid.m_hWnd)
		return;

	CRect rctClient;
	GetClientRect(rctClient);
	m_wndGrid.MoveWindow(rctClient);
}

std::string CChildView::GetErrorMessage(HRESULT hRes)
{
	std::string sError;
	ISupportErrorInfo *pISER;
	if(SUCCEEDED(m_wndGrid.GetControlUnknown()->QueryInterface(IID_ISupportErrorInfo,(void**)&pISER)))
	{
		if(SUCCEEDED(pISER->InterfaceSupportsErrorInfo(IID_IMDZSimpleGrid)))
		{
			IErrorInfo *pEI;
			if(SUCCEEDED(GetErrorInfo(NULL,&pEI)))
			{
				BSTR bstrDescr;
				pEI->GetDescription(&bstrDescr);
				USES_CONVERSION;
				sError=W2A(bstrDescr);
				SysFreeString(bstrDescr);
				pEI->Release();
			}
		}
		pISER->Release();
	}
	return sError;
}

